# coding: utf-8

import re
import sys

args = sys.argv[1:]
if len(args) != 1:
    print 'Usage: txt2tei.py input.txt'
    sys.exit()

page = re.compile(r'(\d+)쪽$')
eos = re.compile(r'[.!]"?$')
quote = re.compile(r'"')
note = re.compile(r'{(\d+)\) ([^}]+)}')

class Quoter:
    def __init__(self, open=False):
        self.open = open
    def __call__(self, match):
        if self.open:
            quote = '</q>'
            self.open = False
        else:
            quote = '<q>'
            self.open = True
        return quote

q = Quoter()

filename = args[0]
f = open(filename, 'r')

print '<?xml version="1.0" encoding="UTF-8"?>'
print '<div>'
print

state = 'head'

for line in f:
    line = line.strip()
    match = page.match(line)
    if match:
        print '<pb n="%s"/>' % match.group(1)
        continue
    if not line:
        print
        continue
    is_eos = eos.search(line)
    line = quote.sub(q, line)
    line = note.sub(r'<note n="\1">\2</note>', line)
    if state == 'head':
        print '<head>%s</head>' % line
        state = 'body'
        continue
    if is_eos:
        if state == 'body':
            print '<p>%s</p>' % line
        elif state == 'para':
            print '%s</p>' % line
            state = 'body'
    else:
        if state == 'body':
            print '<p>%s' % line
            state = 'para'
        elif state == 'parap':
            print '%s' % line

print
print '</div>'
